=== debian/changelog ===
fio (3.12-2) unstable; urgency=medium

  * control: Depend on libglusterfs-dev instead of glusterfs-common
    (Closes: #919670).
  * control: Bumped standards version to 4.3.0, no changes needed.

 -- Martin Steigerwald <martin.steigerwald@proact.de>  Mon, 21 Jan 2019 09:29:38 +0100

fio (3.12-1) unstable; urgency=medium

  * Imported upstream version 3.12.
  * patches: Refreshed.
  * copyright: Removed engines/fusion-aw.c, removed by upstream.
  * control: Bumped standards version to 4.2.1, no changes needed.

 -- Martin Steigerwald <martin.steigerwald@proact.de>  Wed, 28 Nov 2018 16:47:49 +0100
