=== debian/control ===
Source: fio
Section: utils
Priority: optional
Maintainer: Martin Steigerwald <martin.steigerwald@proact.de>
Build-Depends: debhelper (>= 11), dpkg-dev (>= 1.16.1~), libaio-dev [linux-any], zlib1g-dev, librdmacm-dev [linux-any], libibverbs-dev [linux-any], librbd-dev [linux-any], libgtk2.0-dev, libcairo2-dev, libnuma-dev [linux-any], flex, bison, libglusterfs-dev
Standards-Version: 4.3.0
Homepage: https://github.com/axboe/fio
Vcs-Git: https://salsa.debian.org/debian/fio.git
Vcs-Browser: https://salsa.debian.org/debian/fio

Package: fio
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python2.7
Suggests: gnuplot, gfio, python-scipy
Description: flexible I/O tester
 fio is a tool that will spawn a number of threads or processes doing a
 particular type of I/O action as specified by the user. fio takes a
 number of global parameters, each inherited by the thread unless
 otherwise parameters given to them overriding that setting is given.
 The typical use of fio is to write a job file matching the I/O load
 one wants to simulate.
 .
 This package contains the command line version of fio and all additional
 command line tools. The package gfio contains the GTK+ based gui frontend
 for fio.

Package: gfio
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: fio
Description: flexible I/O tester - gui frontend
 fio is a tool that will spawn a number of threads or processes doing a
 particular type of I/O action as specified by the user. fio takes a
 number of global parameters, each inherited by the thread unless
 otherwise parameters given to them overriding that setting is given.
 The typical use of fio is to write a job file matching the I/O load
 one wants to simulate.
 .
 This package contains the GTK+ based gui frontend for fio. The package
 fio contains the command line version of fio which acts as a backend
 to the GUI frontend. The frontend can talk to a locally or remotely
 running fio server.
