=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_LDFLAGS_MAINT_PREPEND := -Wl,-z,defs -Wl,--as-needed

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export V = 1

%:
	dh $@

override_dh_auto_configure:
	./configure --disable-native --prefix=/usr --enable-gfio

override_dh_installsystemd:
	dh_installsystemd --no-start --no-enable

# dh_installinit --no-start --no-enable gives update-rc.d: error: no runlevel symlinks to modify, aborting!
# https://bugs.debian.org/894084
override_dh_installinit:
	dh_installinit --no-scripts --no-start --no-enable
