=== debian/changelog ===
fio (3.16-1) unstable; urgency=medium

  [ Sven Hoexter ]
  * Import new upstream version 3.16. Closes: #942537
  * Add debian/patches/fix-compilation-3.16 to fix the compilation of
    3.16. Picked from upstream master 5b215853ed4b438b5b2d4ac3e56d5f0d19e145d9.

 -- Sven Hoexter <hoexter@debian.org>  Mon, 21 Oct 2019 09:50:07 +0200

fio (3.15-1) unstable; urgency=medium

  [ Martin Steigerwald ]
  * Imported new upstream version 3.15:
    * New engine 'io_uring' for new IO uring asynchronous I/O interface
      of Linux.
    * New engine 'libiscsi' for iSCSI targets.
    * Addresses bug #929579 for upstream related changes to support cross
      building (see messages 15 and 20 of this bug report).
  * patches: Refreshed.
  * control: Bumped standards version to 4.4.0.1, no changes needed.

  [ Sven Hoexter ]
  * Bump Standards-Version to 4.4.1, no changes required.
  * Export CROSS_COMPILE when required to allow cross compilation.
    Patch provided by Helmut Grohne. Closes: #929579

 -- Sven Hoexter <hoexter@debian.org>  Sun, 20 Oct 2019 19:48:57 +0200
