=== debian/watch ===
version=4
opts=pgpmode=mangle
opts=pgpsigurlmangle=s/$/.asc/ http://brick.kernel.dk/snaps/fio-(\d.*)\.tar\.gz
