=== debian/changelog ===
fio (3.25-2) unstable; urgency=medium

  * Moved manpage for 'fiologparser_hist.py' into '/usr/share/doc/fio'
    as well to fix manpage being installed with language 'py'.

 -- Martin Steigerwald <martin.steigerwald@proact.de>  Tue, 22 Dec 2020 11:07:22 +0100

fio (3.25-1) unstable; urgency=medium

  * Imported new upstream version 3.25.
  * patches:
    * Refreshed.
    * Removed 'makefile-hardening'. Upstream makefile should no longer
      override user CFLAGS.
  * control: Bumped standards version to 4.5.1.

 -- Martin Steigerwald <martin.steigerwald@proact.de>  Mon, 21 Dec 2020 16:52:09 +0100

fio (3.23-1) unstable; urgency=medium

  * Imported new upstream version 3.23.

 -- Martin Steigerwald <martin.steigerwald@proact.de>  Wed, 11 Nov 2020 16:16:31 +0100

fio (3.21-1) unstable; urgency=medium

  * Imported new upstream version 3.21.
    * Fixes: ftbfs with GCC-10 (Closes: #957204).
    * Fixes: fio: Python2 removal in sid/bullseye (Closes: #957204).
  * control: Switched Python dependency to python3 as all scripts work with
    Python 3 now.

 -- Martin Steigerwald <martin.steigerwald@proact.de>  Wed, 22 Jul 2020 14:49:05 +0200

fio (3.20-1) unstable; urgency=medium

  * Imported new upstream version 3.20.
  * patches: Refreshed.
  * Bumped debhelper compat level from 11 to 13:
    * Adapted paths to files reported by 'dh_missing'.
    * Added some new files reported by 'dh_missing'.
  * Allow build without root privileges. Produces the same binaries
    according to diffoscope.

 -- Martin Steigerwald <martin.steigerwald@proact.de>  Tue, 02 Jun 2020 16:34:25 +0200

fio (3.19-2) unstable; urgency=medium

  * Re-Release for a source only upload. Package is unchanged.

 -- Sven Hoexter <hoexter@debian.org>  Sat, 11 Apr 2020 13:17:44 +0200

fio (3.19-1) unstable; urgency=medium

  * Imported new upstream version 3.19.
  * patches:
    * Refreshed.
    * fix-compilation-3.16: Removed, applied upstream.
    * genfio-interpreter: Removed, changed accordingly by upstream.
  * Enable persistent memory based engines in fio by adding libpmem-dev
    and libpmemblk-dev to build dependencies. Thanks to Adam Borowski
    for bug report and patch (Closes: #950848).
  * watch: Use HTTPS URL.
  * control: Bumped standards version to 4.5.0.
  * rules: Removed '--no-scripts' from dh_installinit to make package
    compliant to standards version 4.5.0. Bug I reported back then
    seems to be fixed (Closes: #894084).

 -- Martin Steigerwald <martin.steigerwald@proact.de>  Wed, 08 Apr 2020 17:24:39 +0200
